const crc_calculator = require("homebridge-tiscontrol-wired/app/crc/crc16");
const  send_to_server = require("homebridge-tiscontrol-wired/app/server");
const  helper = require("homebridge-tiscontrol-wired/app/helper");

exports.BeeCurtain = void 0;

const HMBOpening = 1;
const HMBClosing = 0;
const HMBStop = 2;

class BeeCurtain {
    constructor(platform, accessory, ip_address, device_name,subnet_id,device_id,channel_id,value,status) {
        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.ip_address=ip_address
        this.status=status
   
        this.RelayCurtainsStates = {
            PositionState: HMBStop,
            CurrentPosition: 0,
            TargetPosition: 0,
        };
        this.TISOpening = 1;
        this.TISClosing = 2;
        this.TISStop = 0;

        if(value==false){

            this.accessory.getService(this.platform.Service.AccessoryInformation)
                .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS Control')
                .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "Bee Curtain");
            this.service = this.accessory.getService(this.platform.Service.WindowCovering) || this.accessory.addService(this.platform.Service.WindowCovering);
            this.service.setCharacteristic(this.platform.Characteristic.Name, device_name);
            this.service.getCharacteristic(this.platform.Characteristic.CurrentPosition)
                .onGet(this.handleCurrentPositionGet.bind(this));
            this.service.getCharacteristic(this.platform.Characteristic.PositionState)
                .onGet(this.handlePositionStateGet.bind(this));
            this.service.getCharacteristic(this.platform.Characteristic.TargetPosition)
                .onGet(this.handleTargetPositionGet.bind(this))
                .onSet(this.handleTargetPositionSet.bind(this));

                  

        }else{
          
            // this.RelayCurtainsStates.CurrentPosition = this.RelayCurtainsStates.TargetPosition;
            // this.service.getCharacteristic(this.platform.Characteristic.CurrentPosition).updateValue(this.RelayCurtainsStates.CurrentPosition);

            // this.platform.log(" constructor "+this.RelayCurtainsStates.TargetPosition)

            this.RelayCurtainsStates.CurrentPosition = this.status.targetposition;
            this.RelayCurtainsStates.PositionState = 2;
            this.RelayCurtainsStates.TargetPosition=this.status.targetposition
            this.service = this.accessory.getService(this.platform.Service.WindowCovering) || this.accessory.addService(this.platform.Service.WindowCovering);
            this.service.setCharacteristic(this.platform.Characteristic.Name, device_name);
            this.service.getCharacteristic(this.platform.Characteristic.TargetPosition).updateValue(this.RelayCurtainsStates.TargetPosition);
            this.service.getCharacteristic(this.platform.Characteristic.CurrentPosition).updateValue(this.RelayCurtainsStates.CurrentPosition);
            this.service.getCharacteristic(this.platform.Characteristic.PositionState).updateValue(this.RelayCurtainsStates.PositionState);
            


        }

        
    }
    async handleTargetPositionSet(targetposition) {

        this.platform.log.debug(" bee curtain targetpostion "+targetposition)
        
            this.RelayCurtainsStates.CurrentPosition = targetposition;
            this.RelayCurtainsStates.PositionState = 2;
            this.RelayCurtainsStates.TargetPosition=targetposition
            
            this.service.getCharacteristic(this.platform.Characteristic.TargetPosition).updateValue(this.RelayCurtainsStates.TargetPosition);
            this.service.getCharacteristic(this.platform.Characteristic.CurrentPosition).updateValue(this.RelayCurtainsStates.CurrentPosition);
            this.service.getCharacteristic(this.platform.Characteristic.PositionState).updateValue(this.RelayCurtainsStates.PositionState);
            
            
            
            let get_value
        
            get_value=helper.numberToHex(targetposition)
            let channel_id=helper.numberToHex(this.channel_id )
            let subnet_id=helper.numberToHex(this.subnet_id )
            let device_id=helper.numberToHex(this.device_id )
            let ip_address=this.ip_address
        
                let set_packet=String("0f01fefffe0031")+subnet_id+device_id+channel_id+get_value+"0000"
                let payload=set_packet
                let get_crc=crc_calculator.payload(payload)
                let send_packet=set_packet+get_crc
                let packet=helper.fullPacket(send_packet)
                send_to_server.udpclient(ip_address,packet)
             


    }


    async handleTargetPositionGet() {
      
        return this.RelayCurtainsStates.TargetPosition;
    }
    async handleCurrentPositionGet() {

        let subnet_id=helper.numberToHex(this.subnet_id )
        let device_id=helper.numberToHex(this.device_id ) 
        let set_packet=String("0b01fefffe0033")+subnet_id+device_id
        let payload=set_packet
        let get_crc=crc_calculator.payload(payload)
        let send_packet=set_packet+get_crc
        let packet=helper.fullPacket(send_packet)
        let log_packet=helper.addSpace(packet)
        this.platform.log.debug(log_packet)
        send_to_server.udpclient(this.ip_address,packet)

       
        return this.RelayCurtainsStates.CurrentPosition;
    }
    async handlePositionStateGet() {
       
        return this.RelayCurtainsStates.PositionState;
    }
}
exports.BeeCurtain = BeeCurtain;
