"use strict";
const crc_calculator = require("homebridge-tiscontrol-wired/app/crc/crc16");
const  send_to_server = require("homebridge-tiscontrol-wired/app/server");
const  helper = require("homebridge-tiscontrol-wired/app/helper");

exports.RelayDimmer = void 0;

class RelayDimmer {
    constructor(platform, accessory, ip_address, device_name,subnet_id,device_id,channel_id,value,status,level) {
        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.ip_address=ip_address
        this.level=level
        this.status=status

        this.RelayDimmableLightbulbStates = {
            On: false,
            Brightness: 0,
        };

        if(value==false){

                this.accessory.getService(this.platform.Service.AccessoryInformation)
                    .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS Control')
                    .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "Dimmer");
                this.service = this.accessory.getService(this.platform.Service.Lightbulb) || this.accessory.addService(this.platform.Service.Lightbulb);
                this.service.setCharacteristic(this.platform.Characteristic.Name, device_name);
                this.service.getCharacteristic(this.platform.Characteristic.On)
                    .onSet(this.setOn.bind(this))
                    .onGet(this.getOn.bind(this));
                this.service.getCharacteristic(this.platform.Characteristic.Brightness)
                    .onSet(this.setBrightness.bind(this))
                    .onGet(this.getBrightness.bind(this));

                // eslint-disable-next-line @typescript-eslint/no-this-alias
                    const that = this;
                    const level = this.level;
                    
                        that.RelayDimmableLightbulbStates.On = (level > 0);
                        that.service.getCharacteristic(that.platform.Characteristic.On).updateValue(that.RelayDimmableLightbulbStates.On);
                        that.RelayDimmableLightbulbStates.Brightness = level;
                        that.service.getCharacteristic(that.platform.Characteristic.Brightness).updateValue(that.RelayDimmableLightbulbStates.Brightness);
                        if (that.RelayDimmableLightbulbStates.On) {
                            that.platform.log.debug(that.device_name + ' is now on with brightness ' + that.RelayDimmableLightbulbStates.Brightness);
                        }
                        else {
                            that.platform.log.debug(that.device_name + ' is now off with brightness ' + that.RelayDimmableLightbulbStates.Brightness);
                        }

            }else{
                if(this.status!==null){

                 
                this.service = this.accessory.getService(this.platform.Service.Lightbulb) || this.accessory.addService(this.platform.Service.Lightbulb);
                this.service.getCharacteristic(this.platform.Characteristic.On).updateValue(this.status);
                this.RelayDimmableLightbulbStates.On=this.status

                this.RelayDimmableLightbulbStates.Brightness = this.level;
                this.service.getCharacteristic(this.platform.Characteristic.Brightness).updateValue(this.RelayDimmableLightbulbStates.Brightness);
                if (this.RelayDimmableLightbulbStates.On) {
                    this.platform.log.debug(this.device_name + ' is now on with brightness ' + this.RelayDimmableLightbulbStates.Brightness);
                }
                else {
                    this.platform.log.debug(this.device_name + ' is now off with brightness ' + this.RelayDimmableLightbulbStates.Brightness);
                }

            
                }
            }

            }
   
    async setOn(value) {
        this.RelayDimmableLightbulbStates.On = value;
        let get_value
        if(value==true){
           get_value=100
        }else{
           get_value=0
        }

         let subnet_id=helper.numberToHex(this.subnet_id )
         let device_id=helper.numberToHex(this.device_id ) 
         let channel_id=helper.numberToHex(this.channel_id )
         
         
         get_value=helper.numberToHex(get_value)  
         let set_packet=String("0f01fefffe0031")+subnet_id+device_id+channel_id+get_value+"0000"
         let payload=set_packet
         let get_crc=crc_calculator.payload(payload)
         let send_packet=set_packet+get_crc
         let packet=helper.fullPacket(send_packet)
         let log_packet=helper.addSpace(packet)
         this.platform.log.debug(log_packet)
         send_to_server.udpclient(this.ip_address,packet)

    }
    async getOn() {
        return this.RelayDimmableLightbulbStates.On;
    }

    async setBrightness(value) {

        this.RelayDimmableLightbulbStates.Brightness = value;

        let subnet_id=helper.numberToHex(this.subnet_id )
        let device_id=helper.numberToHex(this.device_id ) 
        let channel_id=helper.numberToHex(this.channel_id )
        
        this.platform.log.debug(" subnet_id "+subnet_id)
        let get_value=helper.numberToHex(value)  
        let set_packet=String("0f01fefffe0031")+subnet_id+device_id+channel_id+get_value+"0000"
        let payload=set_packet
        let get_crc=crc_calculator.payload(payload)
        let send_packet=set_packet+get_crc
        let packet=helper.fullPacket(send_packet)
        let log_packet=helper.addSpace(packet)
        this.platform.log.debug(log_packet)
        send_to_server.udpclient(this.ip_address,packet)
    }
  
    async getBrightness() {

        let subnet_id=helper.numberToHex(this.subnet_id )
        let device_id=helper.numberToHex(this.device_id ) 
        let set_packet=String("0b01fefffe0033")+subnet_id+device_id
        let payload=set_packet
        let get_crc=crc_calculator.payload(payload)
        let send_packet=set_packet+get_crc
        let packet=helper.fullPacket(send_packet)
        let log_packet=helper.addSpace(packet)
        this.platform.log.debug(log_packet)
        send_to_server.udpclient(this.ip_address,packet)
        return this.RelayDimmableLightbulbStates.Brightness;
    }
}
exports.RelayDimmer = RelayDimmer;