const crc_calculator = require("homebridge-tiscontrol-wired/app/crc/crc16");
const  send_to_server = require("homebridge-tiscontrol-wired/app/server");
const  helper = require("homebridge-tiscontrol-wired/app/helper");

exports.FloorHeater = void 0;

class FloorHeater {
    constructor(platform, accessory, ip_address,device_name,subnet_id,device_id,channel_id,value,status,scale) {
        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.ip_address=ip_address
        this.status_data=status
        this.scale=scale
        
        this.RelayLightbulbStates = {
            On: false,
        };
        this.FloorHeater={
          
          On: false,
          FHStatus:0,
          FHAmbient : 33,
          FHSetpoint : 16,
          Scale:1

        }
        let minValue,maxValue,minStep
        if(this.scale=="Fahrenheit" || this.scale=="F"){

          minValue= 10,
          maxValue= 86,
          minStep= 1

        }else{

          minValue= 10,
          maxValue= 30,
          minStep= 1

        }
      

        if(value==false){

        this.accessory.getService(this.platform.Service.AccessoryInformation)
            .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS Control')
            .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "Floor Heater");
        this.service = this.accessory.getService(this.platform.Service.Thermostat) || this.accessory.addService(this.platform.Service.Thermostat);
        this.service.setCharacteristic(this.platform.Characteristic.Name, device_name);

        this.service.getCharacteristic(this.platform.Characteristic.Active).setProps({
            maxValue: 1,
            minValue: 0,
            validValues: [0,1]
            });
    

        this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState)
            .onGet(this.getOn.bind(this));

            this.service.getCharacteristic(this.platform.Characteristic.TargetHeatingCoolingState)
            .onGet(this.handleTargetHeatingCoolingStateGet.bind(this))
            .setProps({
                maxValue: 1,
                minValue: 0,
                validValues: [0,1]
              })
            .onSet(this.handleTargetHeatingCoolingStateSet.bind(this));


            this.service.getCharacteristic(this.platform.Characteristic.CurrentTemperature)
            .onGet(this.handleCurrentTemperatureGet.bind(this));
    
          this.service.getCharacteristic(this.platform.Characteristic.TargetTemperature)
            .onGet(this.handleTargetTemperatureGet.bind(this)).setProps({
              minValue: minValue,
              maxValue: maxValue,
              minStep: minStep,
            })
            .onSet(this.handleTargetTemperatureSet.bind(this));
    
          this.service.getCharacteristic(this.platform.Characteristic.TemperatureDisplayUnits)
            .onGet(this.handleTemperatureDisplayUnitsGet.bind(this))
            .onSet(this.handleTemperatureDisplayUnitsSet.bind(this));

            }else{

              this.FloorHeater.On=this.status_data.On
              this.FloorHeater.FHAmbient=this.status_data.FHAmbient
              this.FloorHeater.FHSetpoint=this.status_data.FHSetpoint
              this.FloorHeater.FHStatus=this.status_data.FHStatus
              this.FloorHeater.Scale=this.status_data.Scale

               this.service = this.accessory.getService(this.platform.Service.Thermostat) || this.accessory.addService(this.platform.Service.Thermostat);
               this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState).updateValue(this.FloorHeater.On)
               this.service.getCharacteristic(this.platform.Characteristic.TargetHeatingCoolingState).updateValue(this.FloorHeater.FHStatus)
               this.service.getCharacteristic(this.platform.Characteristic.CurrentTemperature).updateValue(this.FloorHeater.FHAmbient)
               this.service.getCharacteristic(this.platform.Characteristic.TargetTemperature).updateValue(this.FloorHeater.FHSetpoint)
               this.service.getCharacteristic(this.platform.Characteristic.TemperatureDisplayUnits).updateValue(this.FloorHeater.Scale)
              
           
           
            }
    }

    async getOn() {

      let subnet_id=helper.numberToHex(this.subnet_id )
      let modify_channel_id=this.channel_id-1
      let device_id=helper.numberToHex(this.device_id) 
      let channel_id=helper.numberToHex(modify_channel_id) 

      let set_packet=String("0c01fefffe1944")+subnet_id+device_id+channel_id
      let payload=set_packet
      let get_crc=crc_calculator.payload(payload)
      let send_packet=set_packet+get_crc
      let packet=helper.fullPacket(send_packet)
      let log_packet=helper.addSpace(packet)
      this.platform.log.debug(log_packet)
      send_to_server.udpclient(this.ip_address,packet)

        return this.FloorHeater.On;
    }

    async handleCurrentHeatingCoolingStateGet() {
        this.platform.log.debug('Triggered GET CurrentHeatingCoolingState');
    
        // set this to a valid value for CurrentHeatingCoolingState
        const currentValue =this.FloorHeater.FHStatus;
    
        return currentValue;
      }

      async handleTargetHeatingCoolingStateGet() {
        this.platform.log.debug('Triggered GET TargetHeatingCoolingState');
    
        // set this to a valid value for TargetHeatingCoolingState
        const currentValue = this.FloorHeater.FHStatus;
    
        return currentValue;
      }


      async handleTargetHeatingCoolingStateSet(value) {
        this.platform.log.debug('Triggered SET TargetHeatingCoolingState:'+value);
        this.FloorHeater.On= (value > 0);
        this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState).updateValue(this.FloorHeater.On)
       
        let subnet_id=helper.numberToHex(this.subnet_id )
        let device_id=helper.numberToHex(this.device_id )
        let status=helper.numberToHex(value) 
        let set_packet=String("0e01fefffee3d8")+subnet_id+device_id+"2214"+status
        let payload=set_packet
        let get_crc=crc_calculator.payload(payload)
        let send_packet=set_packet+get_crc
        let packet=helper.fullPacket(send_packet)
        let log_packet=helper.addSpace(packet)
        this.platform.log.debug(log_packet)
        send_to_server.udpclient(this.ip_address,packet)
        //getOn()

      }

      async handleCurrentTemperatureGet() {
        this.platform.log.debug('Triggered GET CurrentTemperature');
    
        // set this to a valid value for CurrentTemperature
        const currentValue = this.FloorHeater.FHAmbient;
    
        return currentValue;
      }
    
      async handleTargetTemperatureGet() {
        this.platform.log.debug('Triggered GET TargetTemperature');
    
        // set this to a valid value for TargetTemperature
        const currentValue = this.FloorHeater.FHSetpoint;
    
        return currentValue;
      }

      async handleTargetTemperatureSet(value) {
        this.platform.log.debug('Triggered SET TargetTemperature:'+value);

        let subnet_id=helper.numberToHex(this.subnet_id )
        let device_id=helper.numberToHex(this.device_id )
        let setpoint=helper.numberToHex(value) 
        let set_packet=String("0e01fefffee3d8")+subnet_id+device_id+"2218"+setpoint
        let payload=set_packet
        let get_crc=crc_calculator.payload(payload)
        let send_packet=set_packet+get_crc
        let packet=helper.fullPacket(send_packet)
        let log_packet=helper.addSpace(packet)
        this.platform.log.debug(log_packet)
        send_to_server.udpclient(this.ip_address,packet)

        this.FloorHeater.FHSetpoint=value
        this.service.getCharacteristic(this.platform.Characteristic.TargetTemperature).updateValue(this.FloorHeater.FHSetpoint)


     

      }

      async handleTemperatureDisplayUnitsGet() {
        this.platform.log.debug('Triggered GET TemperatureDisplayUnits');
    
        // set this to a valid value for TemperatureDisplayUnits
        const currentValue = this.FloorHeater.Scale;
    
        return currentValue;
      }

      async handleTemperatureDisplayUnitsSet(value) {
        this.platform.log.debug('Triggered Floor Heater SET TemperatureDisplayUnits:'+value);
        this.FloorHeater.Scale=value
        this.service.getCharacteristic(this.platform.Characteristic.TemperatureDisplayUnits).updateValue(this.FloorHeater.Scale)

      }

      async formatAsDisplayTemperature(t) {
        let precision = 0.001;
        return (precision * Math.round(t / precision)) + ' °C / ' + (precision * Math.round(this.celsiusToFahrenheit(t) / precision)) + ' °F';
    }

    async celsiusToFahrenheit(temperature) {

      return (temperature * 1.8) + 32;

    }

      


}
exports.FloorHeater = FloorHeater;