"use strict";

exports.RGB = void 0;
const converter = require('color-convert');
const crc_calculator = require("homebridge-tiscontrol-wired/app/crc/crc16");
const  send_to_server = require("homebridge-tiscontrol-wired/app/server");
const  helper = require("homebridge-tiscontrol-wired/app/helper");


class RGB {
    constructor(platform, accessory,ip_address, device_name,subnet_id,device_id,channel_id,green_id,blue_id) {
        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.green_id=green_id
        this.blue_id=blue_id
        this.ip_address=ip_address
       

        this.RGBLightBrightness = {
            On: false,
            Brightness: 0,
            Hue:201,
            Saturation:40
        };
        this.accessory.getService(this.platform.Service.AccessoryInformation)
            .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS')
            .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "RGB");
        this.service = this.accessory.getService(this.platform.Service.Lightbulb) || this.accessory.addService(this.platform.Service.Lightbulb);
        this.service.setCharacteristic(this.platform.Characteristic.Name, this.device_name);
        this.service.getCharacteristic(this.platform.Characteristic.On)
            .onSet(this.setOn.bind(this))
            .onGet(this.getOn.bind(this));
        this.service.getCharacteristic(this.platform.Characteristic.Brightness)
            .onSet(this.setBrightness.bind(this))
            .onGet(this.getBrightness.bind(this));

            this.service.getCharacteristic(this.platform.Characteristic.Saturation)
            .onSet(this.setSaturation.bind(this))
            .onGet(this.getSaturation.bind(this));

            this.service.getCharacteristic(this.platform.Characteristic.Hue)
            .onSet(this.setHue.bind(this))
            .onGet(this.getHue.bind(this));


        // eslint-disable-next-line @typescript-eslint/no-this-alias
             const that = this;
             const level = 25;
                that.RGBLightBrightness.On = (level > 0);
                that.service.getCharacteristic(that.platform.Characteristic.On).updateValue(that.RGBLightBrightness.On);
                that.RGBLightBrightness.Brightness = level;
                that.service.getCharacteristic(that.platform.Characteristic.Brightness).updateValue(that.RGBLightBrightness.Brightness);
                if (that.RGBLightBrightness.On) {
                    that.platform.log.debug(that.device_name + ' is now on with brightness ' + that.RGBLightBrightness.Brightness);
                }
                else {
                    that.platform.log.debug(that.device_name + ' is now off with brightness ' + that.RGBLightBrightness.Brightness);
                }
            }
   
    async setOn(value) {

        this.platform.log.debug( 'rgb light status ' +value);
       
        this.RGBLightBrightness.On = value;

        if(value>0){

            this.RGBLightBrightness.Hue=160
            this.RGBLightBrightness.Saturation=25
            this.RGBLightBrightness.Brightness=25

        var rgb = converter.hsv.rgb([this.RGBLightBrightness.Hue, this.RGBLightBrightness.Saturation, this.RGBLightBrightness.Brightness]);
        this.updateRGB(rgb[0], rgb[1], rgb[2]);

        }else{
            this.RGBLightBrightness.Hue=0
            this.RGBLightBrightness.Saturation=0
            this.RGBLightBrightness.Brightness=0
            var rgb = converter.hsv.rgb([this.RGBLightBrightness.Hue, this.RGBLightBrightness.Saturation, this.RGBLightBrightness.Brightness]);
            this.updateRGB(rgb[0], rgb[1], rgb[2]);


        }

    }
    async getOn() {
        return this.RGBLightBrightness.On;
    }

    async setBrightness(value) {

        this.platform.log.debug(this.device_name + ' is now off with brightness ' +value);

        this.RGBLightBrightness.Brightness = value;

        var rgb = converter.hsv.rgb([this.RGBLightBrightness.Hue, this.RGBLightBrightness.Saturation, this.RGBLightBrightness.Brightness]);
        this.updateRGB(rgb[0], rgb[1], rgb[2]);
    }
  
    async getBrightness() {
        return this.RGBLightBrightness.Brightness;
    }

    async setSaturation(value) {

        this.platform.log.debug(this.device_name + ' Saturation ' +value);
        this.RGBLightBrightness.Saturation = value;
        var rgb = converter.hsv.rgb([this.RGBLightBrightness.Hue, this.RGBLightBrightness.Saturation, this.RGBLightBrightness.Brightness]);
        this.updateRGB(rgb[0], rgb[1], rgb[2]);

    }
  
    async getSaturation() {
        return this.RGBLightBrightness.Saturation;
    }

    async setHue(value) {

        this.platform.log.debug(this.device_name + ' Hue ' +value);
        this.RGBLightBrightness.Hue = value;

        var rgb = converter.hsv.rgb([this.RGBLightBrightness.Hue, this.RGBLightBrightness.Saturation, this.RGBLightBrightness.Brightness]);
        this.updateRGB(rgb[0], rgb[1], rgb[2]);
       
    }
  
    async getHue() {
        return this.RGBLightBrightness.Hue;
    }


    async updateRGB(red, green, blue){
      
        let r= parseInt(red)/2.55
        let g= parseInt(green)/2.55
        let b= parseInt(blue)/2.55
        

        let redColorValue =Math.round(r)
        let greenColorValue =Math.round(g)
        let blueColorValue =Math.round(b)

        this.platform.log.debug("red color "+redColorValue);
        this.platform.log.debug("green color "+greenColorValue);
        this.platform.log.debug("blue color "+blueColorValue);
        
        let channel_id=this.channel_id
        let green_id=this.green_id
        let blue_id=this.blue_id

         this.send_to_server(redColorValue,channel_id)
         this.send_to_server(greenColorValue,green_id)
         this.send_to_server(blueColorValue,blue_id)
        
    }
    async send_to_server(value,value_id){
      
        let subnet_id=helper.numberToHex(this.subnet_id )
        let device_id=helper.numberToHex(this.device_id ) 
        let channel_id=helper.numberToHex(value_id)

        let get_value=helper.numberToHex(value)  
        let set_packet=String("0f01fefffe0031")+subnet_id+device_id+channel_id+get_value+"0000"
        let payload=set_packet
        let get_crc=crc_calculator.payload(payload)
        let send_packet=set_packet+get_crc
        let packet=helper.fullPacket(send_packet)
        let log_packet=helper.addSpace(packet)
        this.platform.log.debug(log_packet)
        send_to_server.udpclient(this.ip_address,packet)


    }
}
exports.RGB = RGB;