const crc_calculator = require("homebridge-tiscontrol-wired/app/crc/crc16");
const  send_to_server = require("homebridge-tiscontrol-wired/app/server");
const  helper = require("homebridge-tiscontrol-wired/app/helper");

exports.IR_TV = void 0;

class IR_TV {
    constructor(platform, accessory,ip_address, device_name,subnet_id,device_id,channel_id) {

        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.ip_address=ip_address
        
        this.RelayLightbulbStates = {
            On: false,
        };

        this.RelayDimmableLightbulbStates = {
          On: false,
          Brightness: 0,
      };

       
  
        this.accessory.getService(this.platform.Service.AccessoryInformation)
            .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS Control')
            .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "IR TV");
        this.service = this.accessory.getService(this.platform.Service.Television) || this.accessory.addService(this.platform.Service.Television);
        this.service.setCharacteristic(this.platform.Characteristic.ConfiguredName, device_name);
        this.service.getCharacteristic(this.platform.Characteristic.Active)
            .onSet(this.setOn.bind(this))
            .onGet(this.getOn.bind(this));

        this.service.setCharacteristic(this.platform.Characteristic.SleepDiscoveryMode,this.platform.Characteristic.SleepDiscoveryMode.ALWAYS_DISCOVERABLE);

        this.service.setCharacteristic(this.platform.Characteristic.ActiveIdentifier, 1);
        this.service.getCharacteristic(this.platform.Characteristic.ActiveIdentifier)
        .onSet((newValue) => {
          this.platform.log('set Active Identifier => setNewValue: ' + newValue);
        });

        this.service.getCharacteristic(this.platform.Characteristic.RemoteKey) .onSet((newValue) => {
          switch(newValue) {
            case this.platform.Characteristic.RemoteKey.REWIND: {
              this.platform.log('set Remote Key Pressed: REWIND');
              break;
            }
            case this.platform.Characteristic.RemoteKey.FAST_FORWARD: {
              this.platform.log('set Remote Key Pressed: FAST_FORWARD');
              break;
            }
            case this.platform.Characteristic.RemoteKey.NEXT_TRACK: {
              this.platform.log('set Remote Key Pressed: NEXT_TRACK');
              break;
            }
            case this.platform.Characteristic.RemoteKey.PREVIOUS_TRACK: {
              this.platform.log('set Remote Key Pressed: PREVIOUS_TRACK');
              break;
            }
            case this.platform.Characteristic.RemoteKey.ARROW_UP: {
              this.platform.log('set Remote Key Pressed: ARROW_UP');
              break;
            }
            case this.platform.Characteristic.RemoteKey.ARROW_DOWN: {
              this.platform.log('set Remote Key Pressed: ARROW_DOWN');
              break;
            }
            case this.platform.Characteristic.RemoteKey.ARROW_LEFT: {
              this.platform.log('set Remote Key Pressed: ARROW_LEFT');
              break;
            }
            case this.platform.Characteristic.RemoteKey.ARROW_RIGHT: {
              this.platform.log('set Remote Key Pressed: ARROW_RIGHT');
              break;
            }
            case this.platform.Characteristic.RemoteKey.SELECT: {
              this.platform.log('set Remote Key Pressed: SELECT');
              break;
            }
            case this.platform.Characteristic.RemoteKey.BACK: {
              this.platform.log('set Remote Key Pressed: BACK');
              break;
            }
            case this.platform.Characteristic.RemoteKey.EXIT: {
              this.platform.log('set Remote Key Pressed: EXIT');
              break;
            }
            case this.platform.Characteristic.RemoteKey.PLAY_PAUSE: {
              this.platform.log('set Remote Key Pressed: PLAY_PAUSE');
              break;
            }
            case this.platform.Characteristic.RemoteKey.INFORMATION: {
              this.platform.log('set Remote Key Pressed: INFORMATION');
              break;
            }
          }
        });

        this.service.getCharacteristic(this.platform.Characteristic.PowerModeSelection).onSet((newValue) => {

          console.log(newValue)
        });

        const tvSpeakerService = this.accessory.addService(this.platform.Service.TelevisionSpeaker);

        tvSpeakerService
        .setCharacteristic(this.platform.Characteristic.Active, this.platform.Characteristic.Active.ACTIVE)
        .setCharacteristic(this.platform.Characteristic.VolumeControlType,this.platform.Characteristic.VolumeControlType.RELATIVE);
  
      // handle volume control
      tvSpeakerService.getCharacteristic(this.platform.Characteristic.Mute)
      .onSet(this.setMute.bind(this))
      .onGet( this.getMute.bind(this));

      tvSpeakerService.getCharacteristic(this.platform.Characteristic.VolumeSelector)
      .onGet(this.setMute.bind(this))
     
        this.service.addLinkedService(tvSpeakerService);

        const volume_control = this.accessory.addService(this.platform.Service.Lightbulb);
       
        volume_control.setCharacteristic(this.platform.Characteristic.ConfiguredName,"VolumeControl");
        volume_control.getCharacteristic(this.platform.Characteristic.Name,"VolumeControl");
        volume_control.getCharacteristic(this.platform.Characteristic.On)
            .onSet(this.setOn.bind(this))
            .onGet(this.getOn.bind(this));
         volume_control.getCharacteristic(this.platform.Characteristic.Brightness)
            .onSet(this.setBrightness.bind(this))
            .onGet(this.getBrightness.bind(this));
    
        this.service.addLinkedService(volume_control);


        const hdmi1InputService = this.accessory.addService(this.platform.Service.InputSource, 'hdmi1', 'HDMI 1');
        hdmi1InputService
          .setCharacteristic(this.platform.Characteristic.Identifier, 1)
          .setCharacteristic(this.platform.Characteristic.ConfiguredName, 'HDMI 1')
          .setCharacteristic(this.platform.Characteristic.IsConfigured, this.platform.Characteristic.IsConfigured.CONFIGURED)
          .setCharacteristic(this.platform.Characteristic.InputSourceType,this.platform.Characteristic.InputSourceType.HDMI);
          this.service.addLinkedService(hdmi1InputService);

          const hdmi2InputService = this.accessory.addService(this.platform.Service.InputSource, 'hdmi2', 'HDMI 2');
          hdmi2InputService
            .setCharacteristic(this.platform.Characteristic.Identifier, 2)
            .setCharacteristic(this.platform.Characteristic.ConfiguredName, 'HDMI 2')
            .setCharacteristic(this.platform.Characteristic.IsConfigured, this.platform.Characteristic.IsConfigured.CONFIGURED)
            .setCharacteristic(this.platform.Characteristic.InputSourceType,this.platform.Characteristic.InputSourceType.HDMI);
            this.service.addLinkedService(hdmi2InputService);

            const netflixInputService  = this.accessory.addService(this.platform.Service.InputSource, 'netflix', 'Netflix');
            netflixInputService 
              .setCharacteristic(this.platform.Characteristic.Identifier, 3)
              .setCharacteristic(this.platform.Characteristic.ConfiguredName, 'Netflix')
              .setCharacteristic(this.platform.Characteristic.IsConfigured, this.platform.Characteristic.IsConfigured.CONFIGURED)
              .setCharacteristic(this.platform.Characteristic.InputSourceType,this.platform.Characteristic.InputSourceType.HDMI);
              this.service.addLinkedService(netflixInputService);

              const amazon  = this.accessory.addService(this.platform.Service.InputSource, 'amazon', 'Amazon');
              amazon 
                .setCharacteristic(this.platform.Characteristic.Identifier,4)
                .setCharacteristic(this.platform.Characteristic.ConfiguredName, 'Amazon')
                .setCharacteristic(this.platform.Characteristic.IsConfigured, this.platform.Characteristic.IsConfigured.CONFIGURED)
                .setCharacteristic(this.platform.Characteristic.InputSourceType,this.platform.Characteristic.InputSourceType.HDMI);
                this.service.addLinkedService(amazon);
 
    }
    async setOn(value) {
        this.platform.log(" set universal switch "+value)
         let status_check= (value>0)
         this.RelayLightbulbStates.On = value 
    }

    async getOn() {
  
      this.platform.log(" universal switch "+this.RelayLightbulbStates.On)
      
      return this.RelayLightbulbStates.On;
      
  }

    async setstate(value) {
      this.platform.log(" set state "+value)
    
  }
    async getstate() {
       
      const currentValue = true;

      return currentValue;
        
    }

    async getMute() {
       
      const currentValue = true;

      return currentValue;
        
    }

    async setMute(value) {
      this.platform.log(" mute value "+value)
    
  }

  async setBrightness(value) {

    this.RelayDimmableLightbulbStates.Brightness = value;

}

async getBrightness() {

    return this.RelayDimmableLightbulbStates.Brightness;
}

   


}
exports.IR_TV = IR_TV;