const crc_calculator = require("homebridge-tiscontrol-wired/app/crc/crc16");
const  send_to_server = require("homebridge-tiscontrol-wired/app/server");
const  helper = require("homebridge-tiscontrol-wired/app/helper");

exports.UniversalSwitch = void 0;

class UniversalSwitch {
    constructor(platform, accessory,ip_address, device_name,subnet_id,device_id,channel_id) {
        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.ip_address=ip_address
        
        this.RelayLightbulbStates = {
            On: false,
        };

        this.accessory.getService(this.platform.Service.AccessoryInformation)
            .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS Control')
            .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "Universal Switch");
        this.service = this.accessory.getService(this.platform.Service.Television) || this.accessory.addService(this.platform.Service.Television);
        this.service.setCharacteristic(this.platform.Characteristic.ConfiguredName, device_name);
        this.service.getCharacteristic(this.platform.Characteristic.Active)
            .onSet(this.setOn.bind(this))
            .onGet(this.getOn.bind(this));
 
    }
    async setOn(value) {
        this.platform.log.debug(" set universal switch "+value)
         

         let status_check= (value>0)
         this.RelayLightbulbStates.On = status_check
         
         let subnet_id=helper.numberToHex(this.subnet_id )
         let device_id=helper.numberToHex(this.device_id ) 
         let channel_id=helper.numberToHex(this.channel_id)
         let level=helper.numberToHex(0)
         if(value>0){
            level=helper.numberToHex(255)
         }


         let set_packet=String("0d01fefffee01c")+subnet_id+device_id+channel_id+level
         let payload=set_packet
         let get_crc=crc_calculator.payload(payload)
         let send_packet=set_packet+get_crc
         let packet=helper.fullPacket(send_packet)
         let log_packet=helper.addSpace(packet)
         this.platform.log.debug(log_packet)
         send_to_server.udpclient(this.ip_address,packet)
        
         
         
    }
    async getOn() {
        this.platform.log.debug(" universal switch "+this.RelayLightbulbStates.On)
      
        return this.RelayLightbulbStates.On;
        
    }


}
exports.UniversalSwitch = UniversalSwitch;