const { HomebridgePluginUiServer, RequestError } = require('@homebridge/plugin-ui-utils');
const { createHash } = require('crypto');

const AuthClient= require('homebridge-tiscontrol-wired/app/auth');

class PluginUiServer extends HomebridgePluginUiServer {
  constructor() {
    // super() MUST be called first
    super();

    // handle request for the /token route
    this.onRequest('/app/homebridge/auth', this.generateToken.bind(this));

    // this MUST be called when you are ready to accept requests
    this.ready();
  }

  async generateToken(payload) {

    const get_data=await AuthClient.AuthClient(payload.token)
   
      if(get_data[0].status){

        console.log("data "+get_data[0].status)

        throw new RequestError('Failed, Please provide valid TIS Access Token');

      }else{
        
        return {
   
          data:get_data
         }

      }

  


    // sleep for 1 second, just to demo async works
    // await new Promise((resolve) => setTimeout(resolve, 10000));

    // try {
    //   // generate a sha256 from the username and use that as a fake token
    //  //const hashedUsername = createHash('sha256').update(payload.username).digest().toString('hex');
    //  console.log("trying the request");
    //   // return data to the ui
    //   const get_data=AuthClient.AuthClient()
    //   console.log("data "+get_data)


 
    //   return {
    //    //token: [{token:hashedUsername}],
    //    data:get_data
    //   }
    // } catch (e) {
    //   throw new RequestError('Failed to Generate Token', { message: e.message });
    // }

  }
}

(() => {
  return new PluginUiServer();
})();